package com.norco.apicustomertest;

import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.norco.API.NorcoAPI;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;

public class DisplayControlActivity extends AppCompatActivity {

    private Button button1;
    private Button button2;
    private Button button3;
    private Button button4;
    private Button button5;
    private Button button6;
    private Button button6_2;
    private Button button7;
    private Button button7_2;
    private Button button8;
    private Button button9;
    private Button button10;
    private Button button11;
    private Button button12;

    private EditText edt1;
    private EditText edt2;
    private EditText edt3;
    private EditText edt4;
    private EditText edt5;
    private EditText edt6;
    private EditText edt6_2;
    private EditText edt7;
    private EditText edt7_2;
    private EditText edt8;
    private EditText edt9;
    private EditText edt10;
    private EditText edt11;
    private EditText edt12;

    private static final String TAG = "norcoAPI";
    private NorcoAPI mNorcoAPI = APIApplication.getApplication().getNorcoAPI();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_display_control);

        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.setHomeButtonEnabled(true);
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        initView();
        mNorcoAPI.norcoAPIRegister();
        setTitle(R.string.button_displaycontrol);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case android.R.id.home:
            this.finish(); // back button
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mNorcoAPI.norcoAPIUnregister();
    }

    private void initView() {
        button1 = (Button)findViewById(R.id.button1);
        button1.setOnClickListener(getResolution);

        button2 = (Button)findViewById(R.id.button2);
        button2.setOnClickListener(setStatusbar);

        button3 = (Button)findViewById(R.id.button3);
        button3.setOnClickListener(setNavigationbar);

        button4 = (Button)findViewById(R.id.button4);
        button4.setOnClickListener(getStatusbar);

        button5 = (Button)findViewById(R.id.button5);
        button5.setOnClickListener(getNavigationbar);

        button6 = (Button)findViewById(R.id.button6);
        button6.setOnClickListener(setRotation);

        button6_2 = (Button)findViewById(R.id.button6_2);
        button6_2.setOnClickListener(setRotation2);

        button7 = (Button)findViewById(R.id.button7);
        button7.setOnClickListener(getRotation);

        button7_2 = (Button)findViewById(R.id.button7_2);
        button7_2.setOnClickListener(getRotation2);

        button8 = (Button)findViewById(R.id.button8);
        button8.setOnClickListener(setScreenMode);

        button9 = (Button)findViewById(R.id.button9);
        button9.setOnClickListener(getScreenMode);

        button10 = (Button)findViewById(R.id.button10);
        button10.setOnClickListener(setScreenBrightness);

        button11 = (Button)findViewById(R.id.button11);
        button11.setOnClickListener(getScreenBrightness);

        button12 = (Button)findViewById(R.id.button12);
        button12.setOnClickListener(setMaxScreenBrightness);

        edt1 = (EditText)findViewById(R.id.edt1);
        edt2 = (EditText)findViewById(R.id.edt2);
        edt3 = (EditText)findViewById(R.id.edt3);
        edt4 = (EditText)findViewById(R.id.edt4);
        edt5 = (EditText)findViewById(R.id.edt5);
        edt6 = (EditText)findViewById(R.id.edt6);
        edt6_2 = (EditText)findViewById(R.id.edt6_2);
        edt7 = (EditText)findViewById(R.id.edt7);
        edt7_2 = (EditText)findViewById(R.id.edt7_2);
        edt8 = (EditText)findViewById(R.id.edt8);
        edt9 = (EditText)findViewById(R.id.edt9);
        edt10 = (EditText)findViewById(R.id.edt10);
        edt11 = (EditText)findViewById(R.id.edt11);
        edt12 = (EditText)findViewById(R.id.edt12);
    }

    private View.OnClickListener getResolution = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button1 getResolution");
            String resolution = mNorcoAPI.dispctrl_getResolution();
            edt1.setText(resolution);
        }
    };

    private View.OnClickListener setStatusbar = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button2 setStatusbar");
            Boolean enable = Boolean.valueOf(edt2.getText().toString());
            mNorcoAPI.dispctrl_setStatusbar(enable);
        }
    };

    private View.OnClickListener setNavigationbar = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button3 setNavigationbar");
            Boolean enable = Boolean.valueOf(edt3.getText().toString());
            mNorcoAPI.dispctrl_setNavigationbar(enable);
        }
    };

    private View.OnClickListener getStatusbar = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button4 getStatusbar");
            Boolean enable = mNorcoAPI.dispctrl_getStatusbar();
            edt4.setText("" + enable);
        }
    };

    private View.OnClickListener getNavigationbar = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button5 getNavigationbar");
            Boolean enable = mNorcoAPI.dispctrl_getNavigationbar();
            edt5.setText("" + enable);
        }
    };

    // 设置主屏幕旋转方向
    private View.OnClickListener setRotation = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            boolean getPrimary = true;
            boolean setPrimary = true;
            Log.i(TAG, "in button6 setRotation");
            String degreeStr = edt6.getText().toString();
            if (TextUtils.isEmpty(degreeStr)) {
                showMessage("请输入旋转角度");
                return;
            }
            if (!TextUtils.isDigitsOnly(degreeStr)) {
                showMessage("请输入整数参数0 1 2 3");
                return;
            }
            int degree = Integer.parseInt(degreeStr);
            if (degree > 3) {
                showMessage("请输入整数参数0 1 2 3");
                return;
            }
            if (degree == mNorcoAPI.dispctrl_getRotation(getPrimary)) {
                showMessage("与当前系统旋转角度一致");
                return;
            }
            mNorcoAPI.dispctrl_setRotation(setPrimary, degree);
        }
    };

    // 获取主屏幕旋转方向
    private View.OnClickListener getRotation = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            boolean getPrimary = true;
            Log.i(TAG, "in button7 getRotation");
            int degree = mNorcoAPI.dispctrl_getRotation(getPrimary);
            edt7.setText("" + degree);
        }
    };

    // 设置副屏幕旋转方向
    private View.OnClickListener setRotation2 = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            boolean getPrimary = false;
            boolean setPrimary = false;
            Log.i(TAG, "in button6_2 setRotation2");
            String degreeStr = edt6_2.getText().toString();
            if (TextUtils.isEmpty(degreeStr)) {
                showMessage("请输入旋转角度");
                return;
            }
            if (!TextUtils.isDigitsOnly(degreeStr)) {
                showMessage("请输入整数参数0 1 2 3");
                return;
            }
            int degree = Integer.parseInt(degreeStr);
            if (degree > 3) {
                showMessage("请输入整数参数0 1 2 3");
                return;
            }
            if (degree == mNorcoAPI.dispctrl_getRotation(getPrimary)) {
                showMessage("与当前系统旋转角度一致");
                return;
            }
            mNorcoAPI.dispctrl_setRotation(setPrimary, degree);
        }
    };

    // 获取副屏幕旋转方向
    private View.OnClickListener getRotation2 = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            boolean getPrimary = false;
            Log.i(TAG, "in button7_2 getRotation2");
            int degree = mNorcoAPI.dispctrl_getRotation(getPrimary);
            edt7_2.setText("" + degree);
        }
    };

    private View.OnClickListener setScreenMode = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button8 setScreenMode");
            String modeStr = edt8.getText().toString();
            if (TextUtils.isEmpty(modeStr)) {
                showMessage("请输入屏幕亮度的调节模式");
                return;
            }
            if (!TextUtils.isDigitsOnly(modeStr)) {
                showMessage("请输入整数参数0 1");
                return;
            }
            int mode = Integer.parseInt(modeStr);
            if (mode > 1) {
                showMessage("请输入整数参数0 1");
                return;
            }
            mNorcoAPI.dispctrl_setScreenMode(mode);
        }
    };

    private View.OnClickListener getScreenMode = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button9 getScreenMode");
            int mode = mNorcoAPI.dispctrl_getScreenMode();
            edt9.setText("" + mode);
        }
    };

    private View.OnClickListener setScreenBrightness = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button10 setScreenBrightness");
            String brightnessStr = edt10.getText().toString();
            if (TextUtils.isEmpty(brightnessStr)) {
                showMessage("屏幕亮度参数错误");
                return;
            }
            if (!TextUtils.isDigitsOnly(brightnessStr)) {
                showMessage("屏幕亮度参数错误");
                return;
            }
            int brightness = Integer.parseInt(brightnessStr);
            mNorcoAPI.dispctrl_setScreenBrightness(brightness);
        }
    };

    private View.OnClickListener getScreenBrightness = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button11 getScreenBrightness");
            int brightness = mNorcoAPI.dispctrl_getScreenBrightness();
            edt11.setText("" + brightness);
        }
    };

    private View.OnClickListener setMaxScreenBrightness = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button12 setMaxScreenBrightness");
            String brightnessStr = edt12.getText().toString();
            if (TextUtils.isEmpty(brightnessStr)) {
                showMessage("最大亮度参数错误");
                return;
            }
            if (!TextUtils.isDigitsOnly(brightnessStr)) {
                showMessage("最大亮度参数错误");
                return;
            }
            int maxBrightness = Integer.parseInt(brightnessStr);
            if (maxBrightness <= 0 || maxBrightness > 255) {
                showMessage("最大亮度参数错误");
                return;
            }

            mNorcoAPI.dispctrl_setMaxScreenBrightness(maxBrightness);
        }
    };

    // 显示Toast消息
    private void showMessage(String sMsg) {
        Toast.makeText(this, sMsg, Toast.LENGTH_SHORT).show();
    }
}
