package com.norco.apicustomertest;

import android.content.Intent;
import android.os.Bundle;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

public class HWControlActivity extends AppCompatActivity {

    private Button buttonUart;
    private Button buttonGpio;
    private Button buttonI2C;
    private Button buttonSPI;
    private Button buttonCAN;
    private Button mButtonAfccontrol;
    private static final String TAG = "norcoAPI";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hw_control);

        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.setHomeButtonEnabled(true);
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        setTitle(R.string.button_hwcontrol);
        initView();
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case android.R.id.home:
            this.finish();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    private void initView() {
        buttonUart = (Button)findViewById(R.id.button_uart);
        buttonUart.setOnClickListener(mUartTest);

        buttonGpio = (Button)findViewById(R.id.button_gpio);
        buttonGpio.setOnClickListener(mGpioTest);

        buttonI2C = (Button)findViewById(R.id.button_i2c);
        buttonI2C.setOnClickListener(mI2CTest);

        buttonSPI = (Button)findViewById(R.id.button_spi);
        buttonSPI.setOnClickListener(mSPITest);

        buttonCAN = (Button)findViewById(R.id.button_can);
        buttonCAN.setOnClickListener(mCANTest);

        mButtonAfccontrol = (Button)findViewById(R.id.button_afccontrol);
        mButtonAfccontrol.setOnClickListener(afcControlTest);
    }

    private View.OnClickListener mUartTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in mUartTest");
            Intent intent = new Intent(HWControlActivity.this, UartActivity.class);
            startActivity(intent);
        }
    };

    private View.OnClickListener mGpioTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Intent intent = new Intent(HWControlActivity.this, GPIOActivity.class);
            startActivity(intent);
        }
    };

    private View.OnClickListener mI2CTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Intent intent = new Intent(HWControlActivity.this, I2CActivity.class);
            startActivity(intent);
        }
    };
    private View.OnClickListener mSPITest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Intent intent = new Intent(HWControlActivity.this, SPIActivity.class);
            startActivity(intent);
        }
    };

    private View.OnClickListener mCANTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Intent intent = new Intent(HWControlActivity.this, CANActivity.class);
            startActivity(intent);
        }
    };

    private View.OnClickListener afcControlTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in afcControlTest");
            Intent intent = new Intent(HWControlActivity.this, AFCControlActivity.class);
            startActivity(intent);
        }
    };
}