package com.norco.apicustomertest;

import android.os.Bundle;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import com.norco.API.NorcoAPI;
import com.norco.API.util.Util;

import java.util.ArrayList;
import java.util.List;

public class NetworkControlActivity extends AppCompatActivity {

    private Button button_getETHMac;
    private TextView text_getETHMac_errorcode;
    private TextView text_getETHMac_errorstr;
    private TextView text_getETHMac;

    private Button button_getWLANMac;
    private TextView text_getWLANMac_errorcode;
    private TextView text_getWLANMac_errorstr;
    private TextView text_getWLANMac;

    private Button button_getIMEI;
    private TextView text_getIMEI_errorcode;
    private TextView text_getIMEI_errorstr;
    private TextView text_getIMEI;

    private Button button_getPhoneNumber;
    private TextView text_getPhoneNumber_errorcode;
    private TextView text_getPhoneNumber_errorstr;
    private TextView text_getPhoneNumber;

    private Button button_setAirplaneMode;
    private TextView text_setAirplaneMode_param_input_hint;
    private TextView text_setAirplaneMode_errorcode;
    private TextView text_setAirplaneMode_errorstr;
    private TextView text_setAirplaneMode;
    private EditText edt_setAirplaneMode_param;

    private Button button_setEthNetworkMode_dhcp;
    private TextView text_setEthNetworkMode_errorcode_dhcp;
    private TextView text_setEthNetworkMode_errorstr_dhcp;
    private TextView text_setEthNetworkMode_dhcp;

    private Button button_setEthNetworkMode;
    private TextView text_setEthNetworkMode_param_input_hint;
    private TextView text_setEthNetworkMode_errorcode;
    private TextView text_setEthNetworkMode_errorstr;
    private TextView text_setEthNetworkMode;
    private EditText edt_setEthNetworkMode_param;

    private Button button_openNetWork;
    private TextView text_openNetWork_param_input_hint;
    private TextView text_openNetWork_errorcode;
    private TextView text_openNetWork_errorstr;
    private TextView text_openNetWork;
    private EditText edt_openNetWork_param;

    private Button button_closeNetWork;
    private TextView text_closeNetWork_param_input_hint;
    private TextView text_closeNetWork_errorcode;
    private TextView text_closeNetWork_errorstr;
    private TextView text_closeNetWork;
    private EditText edt_closeNetWork_param;


    private Button button_getCurrentNetworkType;
    private TextView text_getCurrentNetworkType_errorcode;
    private TextView text_getCurrentNetworkType_errorstr;
    private TextView text_getCurrentNetworkType;

    private Spinner spinner_dhcp, spinner_static;
    private Spinner spinner_opennetwork, spinner_closenetwork;

    private static final String TAG = "norcoAPI";
    private NorcoAPI mNorcoAPI = APIApplication.getApplication().getNorcoAPI();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_network_control);

        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.setHomeButtonEnabled(true);
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        initView();
        mNorcoAPI.norcoAPIRegister();
        setTitle(R.string.button_networkcontrol);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case android.R.id.home:
            this.finish(); // back button
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mNorcoAPI.norcoAPIUnregister();
    }

    private void initView() {
        button_getETHMac = (Button)findViewById(R.id.button_getETHMac);
        button_getETHMac.setOnClickListener(getETHMac);
        text_getETHMac_errorcode = (TextView)findViewById(R.id.text_getETHMac_errorcode);
        text_getETHMac_errorstr = (TextView)findViewById(R.id.text_getETHMac_errorstr);
        text_getETHMac = (TextView)findViewById(R.id.text_getETHMac);


        button_getWLANMac = (Button)findViewById(R.id.button_getWLANMac);
        button_getWLANMac.setOnClickListener(getWLANMac);
        text_getWLANMac_errorcode = (TextView)findViewById(R.id.text_getWLANMac_errorcode);
        text_getWLANMac_errorstr = (TextView)findViewById(R.id.text_getWLANMac_errorstr);
        text_getWLANMac = (TextView)findViewById(R.id.text_getWLANMac);


        button_getIMEI = (Button)findViewById(R.id.button_getIMEI);
        button_getIMEI.setOnClickListener(getIMEI);
        text_getIMEI_errorcode = (TextView)findViewById(R.id.text_getIMEI_errorcode);
        text_getIMEI_errorstr = (TextView)findViewById(R.id.text_getIMEI_errorstr);
        text_getIMEI = (TextView)findViewById(R.id.text_getIMEI);


        button_getPhoneNumber = (Button)findViewById(R.id.button_getPhoneNumber);
        button_getPhoneNumber.setOnClickListener(getPhoneNumber);
        text_getPhoneNumber_errorcode = (TextView)findViewById(R.id.text_getPhoneNumber_errorcode);
        text_getPhoneNumber_errorstr = (TextView)findViewById(R.id.text_getPhoneNumber_errorstr);
        text_getPhoneNumber = (TextView)findViewById(R.id.text_getPhoneNumber);


        button_setAirplaneMode = (Button)findViewById(R.id.button_setAirplaneMode);
        button_setAirplaneMode.setOnClickListener(setAirplaneMode);
        text_setAirplaneMode_param_input_hint =
                (TextView)findViewById(R.id.text_setAirplaneMode_param_input_hint);
        text_setAirplaneMode_errorcode =
                (TextView)findViewById(R.id.text_setAirplaneMode_errorcode);
        text_setAirplaneMode_errorstr = (TextView)findViewById(R.id.text_setAirplaneMode_errorstr);
        text_setAirplaneMode = (TextView)findViewById(R.id.text_setAirplaneMode);
        edt_setAirplaneMode_param = (EditText)findViewById(R.id.edt_setAirplaneMode_param);

        button_setEthNetworkMode_dhcp = (Button)findViewById(R.id.button_setEthNetworkMode_dhcp);
        button_setEthNetworkMode_dhcp.setOnClickListener(setEthNetworkModeDhcp);
        text_setEthNetworkMode_errorcode_dhcp =
                (TextView)findViewById(R.id.text_setEthNetworkMode_errorcode_dhcp);
        text_setEthNetworkMode_errorstr_dhcp =
                (TextView)findViewById(R.id.text_setEthNetworkMode_errorstr_dhcp);
        text_setEthNetworkMode_dhcp = (TextView)findViewById(R.id.text_setEthNetworkMode_dhcp);

        button_setEthNetworkMode = (Button)findViewById(R.id.button_setEthNetworkMode);
        button_setEthNetworkMode.setOnClickListener(setEthNetworkMode);
        text_setEthNetworkMode_param_input_hint =
                (TextView)findViewById(R.id.text_setEthNetworkMode_param_input_hint);
        text_setEthNetworkMode_errorcode =
                (TextView)findViewById(R.id.text_setEthNetworkMode_errorcode);
        text_setEthNetworkMode_errorstr =
                (TextView)findViewById(R.id.text_setEthNetworkMode_errorstr);
        text_setEthNetworkMode = (TextView)findViewById(R.id.text_setEthNetworkMode);
        edt_setEthNetworkMode_param = (EditText)findViewById(R.id.edt_setEthNetworkMode_param);

        button_openNetWork = (Button)findViewById(R.id.button_openNetWork);
        button_openNetWork.setOnClickListener(openNetWork);
        text_openNetWork_param_input_hint =
                (TextView)findViewById(R.id.text_openNetWork_param_input_hint);
        text_openNetWork_errorcode = (TextView)findViewById(R.id.text_openNetWork_errorcode);
        text_openNetWork_errorstr = (TextView)findViewById(R.id.text_openNetWork_errorstr);
        text_openNetWork = (TextView)findViewById(R.id.text_openNetWork);
        edt_openNetWork_param = (EditText)findViewById(R.id.edt_openNetWork_param);


        button_closeNetWork = (Button)findViewById(R.id.button_closeNetWork);
        button_closeNetWork.setOnClickListener(closeNetWork);
        text_closeNetWork_param_input_hint =
                (TextView)findViewById(R.id.text_closeNetWork_param_input_hint);
        text_closeNetWork_errorcode = (TextView)findViewById(R.id.text_closeNetWork_errorcode);
        text_closeNetWork_errorstr = (TextView)findViewById(R.id.text_closeNetWork_errorstr);
        text_closeNetWork = (TextView)findViewById(R.id.text_closeNetWork);
        edt_closeNetWork_param = (EditText)findViewById(R.id.edt_closeNetWork_param);


        button_getCurrentNetworkType = (Button)findViewById(R.id.button_getCurrentNetworkType);
        button_getCurrentNetworkType.setOnClickListener(getCurrentNetworkType);
        text_getCurrentNetworkType_errorcode =
                (TextView)findViewById(R.id.text_getCurrentNetworkType_errorcode);
        text_getCurrentNetworkType_errorstr =
                (TextView)findViewById(R.id.text_getCurrentNetworkType_errorstr);
        text_getCurrentNetworkType = (TextView)findViewById(R.id.text_getCurrentNetworkType);

        spinner_dhcp = (Spinner)findViewById(R.id.spinner_dhcp);
        spinner_static = (Spinner)findViewById(R.id.spinner_static);
        spinner_opennetwork = (Spinner)findViewById(R.id.spinner_opennetwork);
        spinner_closenetwork = (Spinner)findViewById(R.id.spinner_closenetwork);
        List<String> ethList = new ArrayList<>();
        ethList.add("eth0");
        ethList.add("eth1");
        ArrayAdapter<String> ethAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, ethList);
        ethAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_dhcp.setAdapter(ethAdapter);
        spinner_static.setAdapter(ethAdapter);
        spinner_opennetwork.setAdapter(ethAdapter);
        spinner_closenetwork.setAdapter(ethAdapter);
    }

    private View.OnClickListener getETHMac = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "get ETHMac");
            String ret = mNorcoAPI.netctrl_getEthMacAddress();
            text_getETHMac.setText(getResources().getString(R.string.text_result) + ret);
            text_getETHMac_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_getETHMac_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener getWLANMac = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "getWLANMac ");
            String ret = mNorcoAPI.netctrl_getWifiMacAddress();
            text_getWLANMac.setText(getResources().getString(R.string.text_result) + ret);
            text_getWLANMac_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_getWLANMac_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };


    private View.OnClickListener getIMEI = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "getWLANMac ");
            String ret = mNorcoAPI.netctrl_getIMEIInfo();
            text_getIMEI.setText(getResources().getString(R.string.text_result) + ret);
            text_getIMEI_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_getIMEI_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };


    private View.OnClickListener getPhoneNumber = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "getPhoneNumber ");
            String ret = mNorcoAPI.netctrl_getMobilePhoneNumber();
            text_getPhoneNumber.setText(getResources().getString(R.string.text_result) + ret);
            text_getPhoneNumber_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_getPhoneNumber_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener setAirplaneMode = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "setAirplaneMode ");
            boolean param_1;

            String booleanParam = edt_setAirplaneMode_param.getText().toString();
            if (booleanParam.equals("true")) {
                text_setAirplaneMode_param_input_hint.setVisibility(View.INVISIBLE);
                param_1 = true;
            } else if (booleanParam.equals("false")) {
                text_setAirplaneMode_param_input_hint.setVisibility(View.INVISIBLE);
                param_1 = false;
            } else {
                text_setAirplaneMode_param_input_hint.setVisibility(View.VISIBLE);
                return;
            }

            mNorcoAPI.netctrl_setAirplaneMode(param_1);
            text_setAirplaneMode.setText(getResources().getString(R.string.text_result));
            text_setAirplaneMode_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_setAirplaneMode_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener setEthNetworkModeDhcp = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            Log.i(TAG, "setEthNetworkMode dhcp");
            int mode = Util.NETWORK_MODE_DHCP;
            String iface = (String)spinner_dhcp.getSelectedItem();
            String ip = "";
            String mask = "";
            String gateway = "";
            String dns1 = "";
            String dns2 = "";
            boolean ret = mNorcoAPI.netctrl_setEthNetworkMode(mode, iface, ip, mask, gateway,
                    dns1, dns2);

            text_setEthNetworkMode_dhcp.setText(getResources().getString(R.string.text_result) + ret);
            text_setEthNetworkMode_errorcode_dhcp.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_setEthNetworkMode_errorstr_dhcp.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener setEthNetworkMode = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "setEthNetworkMode static");
            String params = edt_setEthNetworkMode_param.getText().toString();
            String[] networkParams = params.split(";");
            if (networkParams.length != 5) {
                text_setEthNetworkMode_param_input_hint.setVisibility(View.VISIBLE);
                return;
            }
            text_setEthNetworkMode_param_input_hint.setVisibility(View.INVISIBLE);

            int mode = Util.NETWORK_MODE_STATIC_IP;
            String iface = (String)spinner_static.getSelectedItem();
            String ip = networkParams[0];
            String mask = networkParams[1];
            String gateway = networkParams[2];
            String dns1 = networkParams[3];
            String dns2 = networkParams[4];
            boolean ret = mNorcoAPI.netctrl_setEthNetworkMode(mode, iface, ip, mask, gateway,
                    dns1, dns2);

            text_setEthNetworkMode.setText(getResources().getString(R.string.text_result) + ret);
            text_setEthNetworkMode_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_setEthNetworkMode_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener openNetWork = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "openNetWork");
            boolean ret = false;
            int type = Util.NETWORK_TYPE_ETH;
            String params = edt_openNetWork_param.getText().toString();

            try {
                type = Integer.parseInt(params);
                text_openNetWork_param_input_hint.setVisibility(View.INVISIBLE);
            } catch (Exception e) {
                e.printStackTrace();
                text_openNetWork_param_input_hint.setVisibility(View.VISIBLE);
                return;
            }

            if (type == Util.NETWORK_TYPE_ETH) {
                String iface = (String)spinner_opennetwork.getSelectedItem();
                ret = mNorcoAPI.netctrl_openNetWork(type, iface);
            } else if (type == Util.NETWORK_TYPE_WIFI) {
                ret = mNorcoAPI.netctrl_openNetWork(type, null);
            }

            text_openNetWork.setText(getResources().getString(R.string.text_result) + ret);
            text_openNetWork_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_openNetWork_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

    private View.OnClickListener closeNetWork = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "closeNetWork");
            boolean ret = false;
            int type = Util.NETWORK_TYPE_ETH;
            String params = edt_closeNetWork_param.getText().toString();

            try {
                type = Integer.parseInt(params);
                text_closeNetWork_param_input_hint.setVisibility(View.INVISIBLE);
            } catch (Exception e) {
                e.printStackTrace();
                text_closeNetWork_param_input_hint.setVisibility(View.VISIBLE);
                return;
            }

            if (type == Util.NETWORK_TYPE_ETH) {
                String iface = (String)spinner_closenetwork.getSelectedItem();
                ret = mNorcoAPI.netctrl_closeNetWork(type, iface);
            } else if (type == Util.NETWORK_TYPE_WIFI) {
                ret = mNorcoAPI.netctrl_closeNetWork(type, null);
            }

            text_closeNetWork.setText(getResources().getString(R.string.text_result) + ret);
            text_closeNetWork_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_closeNetWork_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };


    private View.OnClickListener getCurrentNetworkType = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "getCurrentNetworkType ");

            int ret = mNorcoAPI.netctrl_getCurrentNetworkType();
            text_getCurrentNetworkType.setText(getResources().getString(R.string.text_result) + ret);
            text_getCurrentNetworkType_errorcode.setText(getResources().getString(R.string.text_errorCode) + mNorcoAPI.norcoAPILastErrorCode());
            text_getCurrentNetworkType_errorstr.setText(getResources().getString(R.string.text_errorStr) + mNorcoAPI.norcoAPILastErrorString());
        }
    };

}
