package com.norco.apicustomertest;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import android.text.TextUtils;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.norco.API.NorcoAPI;
import com.norco.API.callback.CheckUpgradeCallback;
import com.norco.API.callback.DownloadAnimationCallback;
import com.norco.API.callback.DownloadUpgradeCallback;
import com.norco.API.callback.InstallCallback;
import com.norco.API.callback.SetTimeCallback;
import com.norco.API.callback.UnInstallCallback;

import java.io.File;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;

public class SystemControlActivity extends AppCompatActivity {

    private Button buttonReboot;
    private Button buttonPoweroff;
    private Button buttonSilenceInstall;
    private EditText editSilenceInstall;
    private Button buttonSilenceUninstall;
    private EditText editSilenceUninstall;
    private Button buttonSettime;
    private Button buttonCheckUpgrade;
    private EditText editCheckUpgrade;
    private Button buttonDownloadUpgrade;
    private EditText editDownloadPackage;
    private Button buttonInstallUpgrade;
    private EditText editInstallPackage;
    private Button buttonGetAlarmOnTime;
    private EditText editGetAlarmOnTime;
    private Button buttonGetAlarmOffTime;
    private EditText editGetAlarmOffTime;
    private Button buttonAlarmpoweron;
    private Button buttonAlarmpoweroff;
    private Button buttonFactoryreset;
    private Button buttonCancelDownload;
    private Button buttonDownAnimation;
    private EditText editDownloadAnimation;
    private Button button15;
    private EditText edit_button15;
    private Button button16;
    private EditText edit_button16;
    private Button button17;
    private Button button18;
    private EditText edit_button18;
    private Button button19;
    private EditText edit_button19;

    private Spinner alarm_power_on_hour, alarm_power_on_minute;
    private Spinner alarm_power_off_hour, alarm_power_off_minute;

    private Spinner spinner_year, spinner_month, spinner_day;
    private Spinner spinner_hour, spinner_minute, spinner_second;

    private Context mContext;
    private static final String TAG = "norcoAPI";
    private NorcoAPI mNorcoAPI = APIApplication.getApplication().getNorcoAPI();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_system_control);

        mContext = this;
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.setHomeButtonEnabled(true);
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        initView();
        initAlarmSpinner();
        mNorcoAPI.norcoAPIRegister();
        setTitle(R.string.button_systemcontrol);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case android.R.id.home:
            this.finish(); // back button
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mNorcoAPI.norcoAPIUnregister();
    }

    private void initView() {
        buttonReboot = (Button)findViewById(R.id.button_reboot);
        buttonReboot.setOnClickListener(rebootTest);

        buttonPoweroff = (Button)findViewById(R.id.button_poweroff);
        buttonPoweroff.setOnClickListener(poweroffTest);

        buttonSilenceInstall = (Button)findViewById(R.id.button_silence_install);
        buttonSilenceInstall.setOnClickListener(silenceInstallTest);
        editSilenceInstall = (EditText)findViewById(R.id.edit_silence_install);

        buttonSilenceUninstall = (Button)findViewById(R.id.button_silence_uninstall);
        buttonSilenceUninstall.setOnClickListener(silenceUninstallTest);
        editSilenceUninstall = (EditText)findViewById(R.id.edit_silence_uninstall);

        buttonSettime = (Button)findViewById(R.id.button_set_time);
        buttonSettime.setOnClickListener(setRtcTimeTest);

        buttonCheckUpgrade = (Button)findViewById(R.id.button_check_upgrade);
        buttonCheckUpgrade.setOnClickListener(checkUpgradeTest);
        editCheckUpgrade = (EditText)findViewById(R.id.edit_check_upgrade);

        buttonDownloadUpgrade = (Button)findViewById(R.id.button_download_package);
        buttonDownloadUpgrade.setOnClickListener(downloadUpgradePackageTest);
        editDownloadPackage = (EditText)findViewById(R.id.edit_download_package);

        buttonCancelDownload = (Button)findViewById(R.id.button_cancel_download);
        buttonCancelDownload.setOnClickListener(cancelDownloadPackageTest);

        buttonInstallUpgrade = (Button)findViewById(R.id.button_install_package);
        buttonInstallUpgrade.setOnClickListener(installUpgradePackageTest);
        editInstallPackage = (EditText)findViewById(R.id.edit_install_package);

        buttonGetAlarmOnTime = (Button)findViewById(R.id.button_get_alarmon_time);
        buttonGetAlarmOnTime.setOnClickListener(getAlarmPowerOnTest);
        editGetAlarmOnTime = (EditText)findViewById(R.id.edit_get_alarmon_time);

        buttonGetAlarmOffTime = (Button)findViewById(R.id.button_get_alarmoff_time);
        buttonGetAlarmOffTime.setOnClickListener(getAlarmPowerOffTest);
        editGetAlarmOffTime = (EditText)findViewById(R.id.edit_get_alarmoff_time);

        buttonAlarmpoweron = (Button)findViewById(R.id.button_alarm_power_on);
        buttonAlarmpoweron.setOnClickListener(alarmPowerOnTest);

        buttonAlarmpoweroff = (Button)findViewById(R.id.button_alarm_power_off);
        buttonAlarmpoweroff.setOnClickListener(alarmPowerOffTest);

        buttonFactoryreset = (Button)findViewById(R.id.button_factory_reset);
        buttonFactoryreset.setOnClickListener(factoryResetTest);

        buttonDownAnimation = (Button)findViewById(R.id.button_download_animation);
        buttonDownAnimation.setOnClickListener(downloadAnimationTest);
        editDownloadAnimation = (EditText)findViewById(R.id.edit_download_animation);

        button15 = (Button)findViewById(R.id.button15);
        button15.setOnClickListener(writeSNTest);
        edit_button15 = (EditText)findViewById(R.id.edit_button15);

        button16 = (Button)findViewById(R.id.button16);
        button16.setOnClickListener(readSNTest);
        edit_button16 = (EditText)findViewById(R.id.edit_button16);

        button17 = (Button)findViewById(R.id.button17);
        button17.setOnClickListener(writeURLMACTest);

        button18 = (Button)findViewById(R.id.button18);
        button18.setOnClickListener(writeMACTest);
        edit_button18 = (EditText)findViewById(R.id.edit_button18);

        button19 = (Button)findViewById(R.id.button19);
        button19.setOnClickListener(readMACTest);
        edit_button19 = (EditText)findViewById(R.id.edit_button19);
    }

    private void initAlarmSpinner() {
        spinner_year = (Spinner)findViewById(R.id.spinner_year);
        spinner_month = (Spinner)findViewById(R.id.spinner_month);
        spinner_day = (Spinner)findViewById(R.id.spinner_day);
        spinner_hour = (Spinner)findViewById(R.id.spinner_hour);
        spinner_minute = (Spinner)findViewById(R.id.spinner_minute);
        spinner_second = (Spinner)findViewById(R.id.spinner_second);

        alarm_power_on_hour = (Spinner)findViewById(R.id.spinner_alarm_power_on_hour);
        alarm_power_on_minute = (Spinner)findViewById(R.id.spinner_alarm_power_on_minute);
        alarm_power_off_hour = (Spinner)findViewById(R.id.spinner_alarm_power_off_hour);
        alarm_power_off_minute = (Spinner)findViewById(R.id.spinner_alarm_power_off_minute);

        List<Integer> year = new ArrayList<>();
        List<Integer> month = new ArrayList<>();
        List<Integer> day = new ArrayList<>();
        List<Integer> ours = new ArrayList<>();
        List<Integer> minute = new ArrayList<>();
        List<Integer> second = new ArrayList<>();
        for (int i = 2019; i < 2026; i++) {
            year.add(i);
        }
        for (int i = 1; i < 13; i++) {
            month.add(i);
        }
        for (int i = 1; i < 30; i++) {
            day.add(i);
        }
        for (int i = -1; i < 24; i++) {
            ours.add(i);
        }

        minute.add(-1);
        for (int i = 0; i < 60; i++) {
            minute.add(i);
            second.add(i);
        }

        ArrayAdapter<Integer> yearAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, year);
        yearAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        ArrayAdapter<Integer> monthAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, month);
        monthAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        ArrayAdapter<Integer> dayAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, day);
        dayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        ArrayAdapter<Integer> ourAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, ours);
        ourAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        ArrayAdapter<Integer> minuteAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, minute);
        minuteAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        ArrayAdapter<Integer> secondAdapter = new ArrayAdapter<Integer>(this, android.R.layout.simple_spinner_item, second);
        secondAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        alarm_power_on_hour.setAdapter(ourAdapter);
        alarm_power_on_hour.setSelection(7);
        alarm_power_off_hour.setAdapter(ourAdapter);
        alarm_power_off_hour.setSelection(20);

        alarm_power_on_minute.setAdapter(minuteAdapter);
        alarm_power_on_minute.setSelection(9);
        alarm_power_off_minute.setAdapter(minuteAdapter);
        alarm_power_off_minute.setSelection(9);

        spinner_year.setAdapter(yearAdapter);
        spinner_year.setSelection(1);
        spinner_month.setAdapter(monthAdapter);
        spinner_month.setSelection(3);
        spinner_day.setAdapter(dayAdapter);
        spinner_day.setSelection(24);
        spinner_hour.setAdapter(ourAdapter);
        spinner_hour.setSelection(13);
        spinner_minute.setAdapter(minuteAdapter);
        spinner_minute.setSelection(9);
        spinner_second.setAdapter(secondAdapter);
        spinner_second.setSelection(9);
    }

    private View.OnClickListener rebootTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in reboot");
            mNorcoAPI.sysctrl_reboot();
        }
    };

    private View.OnClickListener poweroffTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in poweroff");
            mNorcoAPI.sysctrl_poweroff();
        }
    };

    private View.OnClickListener silenceInstallTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            String apkPath = editSilenceInstall.getText().toString();
            Log.i(TAG, "in silenceInstall...apkPath=" + apkPath);
            if (!new File(apkPath).exists()) {
                showMessage("apk文件不存在，请检查路径");
                return;
            }
            mNorcoAPI.sysctrl_silenceInstall(apkPath, new InstallCallback() {
                @Override
                public void onResult(boolean isSuccess) {
                    Log.i(TAG, "in silenceInstall...onResult=" + isSuccess);
                }
            });
        }
    };

    private View.OnClickListener silenceUninstallTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            String pkgName = editSilenceUninstall.getText().toString();
            if (TextUtils.isEmpty(pkgName)) {
                showMessage("卸载包名不能为空");
                return;
            }

            ApplicationInfo info = null;
            try {
                PackageManager packageManager = mContext.getPackageManager();
                info = packageManager.getApplicationInfo(pkgName, PackageManager.GET_UNINSTALLED_PACKAGES);
            } catch (PackageManager.NameNotFoundException e) {
                e.printStackTrace();
            }
            if (info == null) {
                showMessage("卸载包名不存在，请检查是否已安装");
                return;
            }

            Log.i(TAG, "in silenceUnInstall...pkgName=" + pkgName);
            mNorcoAPI.sysctrl_silenceUninstall(pkgName, new UnInstallCallback() {
                @Override
                public void onResult(boolean isSuccess) {
                    Log.i(TAG, "in silenceUninstall...onResult=" + isSuccess);
                }
            });
        }
    };

    private View.OnClickListener setRtcTimeTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            int year = (Integer)spinner_year.getSelectedItem();
            int month = (Integer)spinner_month.getSelectedItem();
            int day = (Integer)spinner_day.getSelectedItem();
            int hour = (Integer)spinner_hour.getSelectedItem();
            int minute = (Integer)spinner_minute.getSelectedItem();
            int second = (Integer)spinner_second.getSelectedItem();

            Calendar calendar = Calendar.getInstance(Locale.getDefault());
            calendar.setTimeInMillis(System.currentTimeMillis());
            calendar.set(Calendar.YEAR, year);
            calendar.set(Calendar.MONTH, month - 1);
            calendar.set(Calendar.DAY_OF_MONTH, day);
            Log.i(TAG, "in set rtc time year=" + year + " month=" + month + " day=" + day);
            calendar.set(Calendar.HOUR_OF_DAY, hour);
            calendar.set(Calendar.MINUTE, minute);
            calendar.set(Calendar.SECOND, second);
            Log.i(TAG, "in set rtc time hour=" + hour + " minute=" + minute + " second=" + second);

            mNorcoAPI.sysctrl_setTime(calendar.getTimeInMillis(), new SetTimeCallback() {
                @Override
                public void onResult(boolean isSuccess) {
                    Log.i(TAG, "in set rtc time...onResult=" + isSuccess);
                }
            });
        }
    };

    private View.OnClickListener checkUpgradeTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in checkUpgrade...");
            String upgradeUrl = editCheckUpgrade.getText().toString();
            if (TextUtils.isEmpty(upgradeUrl)) {
                showMessage("检测系统升级服务器地址不能为空");
                return;
            }
            mNorcoAPI.sysctrl_upgradeCheck(upgradeUrl, new CheckUpgradeCallback() {
                @Override
                public void onResult(boolean hasUpgrade) {
                    Log.i(TAG, "in checkUpgrade...hasUpgrade=" + hasUpgrade);
                    if (hasUpgrade) {
                        editCheckUpgrade.setText("true");
                    } else {
                        editCheckUpgrade.setText("false");
                    }
                }
            });
        }
    };

    private View.OnClickListener downloadUpgradePackageTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in downloadUpgradePackage...");
            String upgradeZipUrl = editDownloadPackage.getText().toString();
            if (TextUtils.isEmpty(upgradeZipUrl)) {
                showMessage("下载系统升级服务器地址不能为空");
                return;
            }
            mNorcoAPI.sysctrl_upgradeDownload(upgradeZipUrl, new DownloadUpgradeCallback() {
                @Override
                public void onSuccess(String saveZipPath) {
                    Log.i(TAG, "in downloadUpgradePackage onSuccess saveZipPath=" + saveZipPath);
                    editDownloadPackage.setText("Success，保存在" + saveZipPath);
                    editInstallPackage.setText(saveZipPath);
                }

                @Override
                public void onCancel() {
                    Log.e(TAG, "in downloadUpgradePackage onCancel");
                    editDownloadPackage.setText("Canceled");
                    editInstallPackage.setText("Canceled");
                }

                @Override
                public void onFailed() {
                    Log.e(TAG, "in downloadUpgradePackage onFailed");
                    editDownloadPackage.setText("Failed");
                    editInstallPackage.setText("Failed");
                }

                @Override
                public void onProgress(int progress) {
                    Log.i(TAG, "in downloadUpgradePackage onProgress=" + progress + "%");
                    editDownloadPackage.setText("下载进度:" + progress + "%");
                }
            });
        }
    };

    private View.OnClickListener cancelDownloadPackageTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in cancelDownloadPackageTest...");
            mNorcoAPI.sysctrl_upgradeDownloadCancel();
        }
    };

    private View.OnClickListener installUpgradePackageTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            String zipPath = editInstallPackage.getText().toString();
            Log.i(TAG, "in installUpgradePackage...zipPath=" + zipPath);
            if (TextUtils.isEmpty(zipPath)) {
                /* /data/media/0在应用层等同于/storage/emulated/0 */
                zipPath = "/data/media/0/update_norco.zip";
            }
            mNorcoAPI.sysctrl_upgradeInstall(zipPath);
        }
    };

    private View.OnClickListener getAlarmPowerOnTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            String alarmTime = mNorcoAPI.sysctrl_getAlarmPowerOnTime();
            Log.i(TAG, "in getAlarmPowerOnTest alarmTime=" + alarmTime);
            editGetAlarmOnTime.setText(alarmTime);
        }
    };

    private View.OnClickListener getAlarmPowerOffTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            String alarmTime = mNorcoAPI.sysctrl_getAlarmPowerOffTime();
            Log.i(TAG, "in getAlarmPowerOffTest alarmTime=" + alarmTime);
            editGetAlarmOffTime.setText(alarmTime);
        }
    };

    private View.OnClickListener alarmPowerOnTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            int hourOfDay = (Integer)alarm_power_on_hour.getSelectedItem();
            int minute = (Integer)alarm_power_on_minute.getSelectedItem();
            Log.i(TAG, "in alarmPowerOnTest hourOfDay=" + hourOfDay + " minute=" + minute);
            boolean isSuccess = mNorcoAPI.sysctrl_setAlarmPowerOnTime(hourOfDay, minute);
            Log.i(TAG, "in alarmPowerOnTest...isSuccess=" + isSuccess);
        }
    };

    private View.OnClickListener alarmPowerOffTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            int hourOfDay = (Integer)alarm_power_off_hour.getSelectedItem();
            int minute = (Integer)alarm_power_off_minute.getSelectedItem();
            Log.i(TAG, "in alarmPowerOffTest hourOfDay=" + hourOfDay + " minute=" + minute);
            boolean isSuccess = mNorcoAPI.sysctrl_setAlarmPowerOffTime(hourOfDay, minute);
            Log.i(TAG, "in alarmPowerOffTest...isSuccess=" + isSuccess);
        }
    };

    private View.OnClickListener factoryResetTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in factoryResetTest...");
            mNorcoAPI.sysctrl_factoryReset();
        }
    };

    private View.OnClickListener downloadAnimationTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in downloadAnimationTest...");
            String animationUrl = editDownloadAnimation.getText().toString();
            mNorcoAPI.sysctrl_bootanimationDownload(animationUrl, new DownloadAnimationCallback() {
                @Override
                public void onCancel() {
                    Log.i(TAG, "in downAnimationTest onCancel");
                }

                @Override
                public void onFailed() {
                    Log.i(TAG, "in downAnimationTest onFailed");
                }

                @Override
                public void onProgress(int progress) {
                    Log.i(TAG, "in downAnimationTest onProgress progress=" + progress);
                }

                @Override
                public void onSuccess(String savePath) {
                    Log.i(TAG, "in downAnimationTest onSuccess savePath=" + savePath);
                }
            });
        }
    };

    private View.OnClickListener writeSNTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in writeSNTest...");
            String sn = edit_button15.getText().toString();
            int ret = mNorcoAPI.sysctrl_writeSN(sn);
            Log.i(TAG, "in writeSNTest ret=" + ret);
        }
    };

    private View.OnClickListener readSNTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in readSNTest...");
            String sn = mNorcoAPI.sysctrl_readSN();
            edit_button16.setText(sn);
            Log.i(TAG, "in readSNTest sn=" + sn);
        }
    };

    private View.OnClickListener writeURLMACTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in writeURLMACTest...");
            int ret = mNorcoAPI.sysctrl_writeURLMAC();
            Log.i(TAG, "in writeURLMACTest ret=" + ret);
        }
    };

    private View.OnClickListener writeMACTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in writeMACTest...");
            String mac = edit_button18.getText().toString();
            int ret = mNorcoAPI.sysctrl_writeMAC(mac);
            Log.i(TAG, "in writeMACTest ret=" + ret);
        }
    };

    private View.OnClickListener readMACTest = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in readMACTest...");
            String mac = mNorcoAPI.sysctrl_readMAC();
            edit_button19.setText(mac);
            Log.i(TAG, "in readMACTest mac=" + mac);
        }
    };

    // 显示Toast消息
    private void showMessage(String sMsg) {
        Toast.makeText(this, sMsg, Toast.LENGTH_SHORT).show();
    }
}
